/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CLOSECONFIRMATION_H_INCLUDED
#define CLOSECONFIRMATION_H_INCLUDED

#include <c4s-document.h>

#include <gtkmm.h>

#include <memory>

class CloseConfirmationDialog: public Gtk::MessageDialog
{
public:
  struct Private;
  class Columns;

  enum Action {
    CANCEL,
    CLOSE_WITHOUT_SAVE,
    SAVE_SELECTED
  };

  class iterator
  {
  public:
    iterator(const Gtk::TreeIter& init, Columns& columns);
    iterator(const iterator& other);

    iterator& operator++();
    iterator operator++(int);

    bool operator==(const iterator& other);
    bool operator!=(const iterator& other);

    C4sDocument* get_document();
    bool get_save();
  protected:
    Columns& m_columns;
    Gtk::TreeIter m_internal;
  };

  CloseConfirmationDialog(Gtk::Window& parent);
  ~CloseConfirmationDialog();

  void add_document(C4sDocument* doc);
  void clear();

  Action launch();

  iterator begin();
  iterator end();
protected:
  std::auto_ptr<Private> m_priv;
};

#endif // CLOSECONFIRMATION_H_INCLUDED
