/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef GOTODIALOG_H_INCLUDED
#define GOTODIALOG_H_INCLUDED

#include <c4scripter/c4s-documentwindow.h>

#include <gtkmm.h>
#include "FileHolder.h"

class GotoDialog: public Gtk::Dialog
{
public:
  GotoDialog(Gtk::Window& parent, FileHolder& file_holder);

private:
  virtual void on_response(int response_id);

  virtual void on_show();
  virtual void on_hide();

  void on_line_focus();
  void on_function_focus();

  static void on_line_changed_static(C4sDocument* document, gpointer user_data) { return static_cast<GotoDialog*>(user_data)->on_line_changed(document); }
  void on_document_changed(C4sDocumentWindow* window);
  void on_line_changed(C4sDocument* document);

  FileHolder& m_file_holder;

  Gtk::Table m_table;

  Gtk::RadioButtonGroup m_group;
  Gtk::RadioButton m_line_button;
  Gtk::RadioButton m_function_button;

  Gtk::SpinButton m_line_entry;
  Gtk::ComboBox m_function_box;

  Gtk::CellRendererPixbuf m_renderer_access;
  Gtk::CellRendererText m_renderer_name;

  sigc::connection m_conn_document_changed;
  sigc::connection m_conn_line_changed;
  //sigc::connection m_conn_function_changed;
};

#endif // GOTODIALOG_H_INCLUDED
