/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __C4S_DOCUMENTWINDOW_H__
#define __C4S_DOCUMENTWINDOW_H__

#include <c4scripter/c4s-scriptview.h>
#include <c4scripter/c4s-functionbar.h>
#include <c4scripter/c4s-document.h>

#include <gtk/gtkvbox.h>

G_BEGIN_DECLS

#define C4S_TYPE_DOCUMENT_WINDOW                   (c4s_document_window_get_type())
#define C4S_DOCUMENT_WINDOW(obj)                   (G_TYPE_CHECK_INSTANCE_CAST((obj), C4S_TYPE_DOCUMENT_WINDOW, C4sDocumentWindow))
#define C4S_DOCUMENT_WINDOW_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST((klass), C4S_TYPE_DOCUMENT_WINDOW, C4sDocumentWindowClass))
#define C4S_IS_DOCUMENT_WINDOW(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), C4S_TYPE_DOCUMENT_WINDOW))
#define C4S_IS_DOCUMENT_WINDOW_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE((klass), C4S_TYPE_DOCUMENT_WINDOW))
#define C4S_DOCUMENT_WINDOW_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS((obj), C4S_TYPE_DOCUMENT_WINDOW, C4sDocumentWindowClass))

typedef struct _C4sDocumentWindowClass C4sDocumentWindowClass;
typedef struct _C4sDocumentWindow C4sDocumentWindow;

struct _C4sDocumentWindowClass
{
  GtkVBoxClass parent_class;
};

struct _C4sDocumentWindow
{
  GtkVBox parent_instance;
};

GType
c4s_document_window_get_type(void) G_GNUC_CONST;

C4sDocumentWindow*
c4s_document_window_new(C4sKeywordList* keywords,
                        C4sEngineFunctionList* engine_list,
                        C4sPreferences* preferences);

C4sDocumentWindow*
c4s_document_window_new_with_document(C4sDocument* document,
                                      C4sKeywordList* keywords,
                                      C4sEngineFunctionList* engine_list,
                                      C4sPreferences* preferences);

C4sDocument*
c4s_document_window_get_document(C4sDocumentWindow* window);

C4sFunctionBar*
c4s_document_window_get_function_bar(C4sDocumentWindow* window);

C4sCustomFunctionList*
c4s_document_window_get_custom_function_list(C4sDocumentWindow* window);

C4sParamInfo*
c4s_document_window_get_param_info(C4sDocumentWindow* window);

C4sScriptView*
c4s_document_window_get_script_view(C4sDocumentWindow* window);

void
c4s_document_window_scroll_to_function(C4sDocumentWindow* window,
                                       C4sCustomFunction* function);

G_END_DECLS

#endif /* __C4S_DOCUMENTWINDOW_H__ */
