/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __C4S_ENGINEFUNCTION_H__
#define __C4S_ENGINEFUNCTION_H__

#include <c4scripter/c4s-function.h>

#include <stdio.h>

G_BEGIN_DECLS

#define C4S_TYPE_ENGINE_FUNCTION			(c4s_engine_function_get_type())
#define C4S_ENGINE_FUNCTION(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), C4S_TYPE_ENGINE_FUNCTION, C4sEngineFunction))
#define C4S_ENGINE_FUNCTION_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST((klass), C4S_TYPE_ENGINE_FUNCTION, C4sEngineFunctionClass))
#define C4S_IS_ENGINE_FUNCTION(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), C4S_TYPE_ENGINE_FUNCTION))
#define C4S_IS_ENGINE_FUNCTION_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), C4S_TYPE_ENGINE_FUNCTION))
#define C4S_ENGINE_FUNCTION_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), C4S_TYPE_ENGINE_FUNCTION, C4sEngineFunctionClass))

typedef struct _C4sEngineFunctionClass C4sEngineFunctionClass;
typedef struct _C4sEngineFunction C4sEngineFunction;

struct _C4sEngineFunctionClass
{
  C4sFunctionClass parent_class;
};

struct _C4sEngineFunction
{
  C4sFunction parent_instance;
};

GType
c4s_engine_function_get_type(void) G_GNUC_CONST;

C4sEngineFunction*
c4s_engine_function_new(const gchar* doc_html,
                        gsize len);

C4sEngineFunction*
c4s_engine_function_new_from_stream(FILE* stream,
                                    GError** error);

gboolean
c4s_engine_function_save(const C4sEngineFunction* function,
                         FILE* stream,
                         GError** error);

G_END_DECLS

#endif /* __C4S_ENGINEFUNCTION_H__ */
