/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __C4S_FUNCTIONBAR_H__
#define __C4S_FUNCTIONBAR_H__

#include <c4scripter/c4s-paraminfo.h>
#include <c4scripter/c4s-customfunctionlist.h>
#include <c4scripter/c4s-enginefunctionlist.h>

#include <gtk/gtkhbox.h>

G_BEGIN_DECLS

#define C4S_TYPE_FUNCTION_BAR                   (c4s_function_bar_get_type())
#define C4S_FUNCTION_BAR(obj)                   (G_TYPE_CHECK_INSTANCE_CAST((obj), C4S_TYPE_FUNCTION_BAR, C4sFunctionBar))
#define C4S_FUNCTION_BAR_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST((klass), C4S_TYPE_FUNCTION_BAR, C4sFunctionBarClass))
#define C4S_IS_FUNCTION_BAR(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), C4S_TYPE_FUNCTION_BAR))
#define C4S_IS_FUNCTION_BAR_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE((klass), C4S_TYPE_FUNCTION_BAR))
#define C4S_FUNCTION_BAR_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS((obj), C4S_TYPE_FUNCTION_BAR, C4sFunctionBarClass))

typedef struct _C4sFunctionBarClass C4sFunctionBarClass;
typedef struct _C4sFunctionBar C4sFunctionBar;

typedef enum _C4sFunctionBarColumns {
  C4S_FUNCTION_BAR_COLUMN_ACCESS,
  C4S_FUNCTION_BAR_COLUMN_NAME,
  C4S_FUNCTION_BAR_COLUMN_FUNCTION,

  C4S_FUNCTION_BAR_N_COLUMNS
} C4sFunctionBarColumns;

struct _C4sFunctionBarClass
{
  GtkHBoxClass parent_class;
};

struct _C4sFunctionBar
{
  GtkHBox parent_instance;
};

GType
c4s_function_bar_get_type(void) G_GNUC_CONST;

GtkWidget*
c4s_function_bar_new(C4sEngineFunctionList* engine_list,
                     C4sCustomFunctionList* custom_list,
		     C4sParamInfo* param_info);

GtkListStore*
c4s_function_bar_get_list_store(C4sFunctionBar* bar);

G_END_DECLS

#endif /* __C4S_FUNCTIONBAR_H__ */
