/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __C4S_OPTIONGROUP_H__
#define __C4S_OPTIONGROUP_H__

#include <gtk/gtkframe.h>
#include <gtk/gtkwidget.h>

G_BEGIN_DECLS

#define C4S_TYPE_OPTION_GROUP             (c4s_option_group_get_type())
#define C4S_OPTION_GROUP(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), C4S_TYPE_OPTION_GROUP, C4sOptionGroup))
#define C4S_OPTION_GROUP_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), C4S_TYPE_OPTION_GROUP, C4sOptionGroupClass))
#define C4S_IS_OPTION_GROUP(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), C4S_TYPE_OPTION_GROUP))
#define C4S_IS_OPTION_GROUP_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), C4S_TYPE_OPTION_GROUP))
#define C4S_OPTION_GROUP_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS((obj), C4S_TYPE_OPTION_GROUP, C4sOptionGroupClass))

typedef struct _C4sOptionGroupClass C4sOptionGroupClass;
typedef struct _C4sOptionGroup C4sOptionGroup;

struct _C4sOptionGroupClass
{
  GtkFrameClass parent_class;
};

struct _C4sOptionGroup
{
  GtkFrame parent_instance;

  GtkWidget* vbox;
};

GType
c4s_option_group_get_type(void) G_GNUC_CONST;

C4sOptionGroup*
c4s_option_group_new(const gchar* label);

G_END_DECLS

#endif /* __C4S_OPTIONGROUP_H__ */
