/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __C4S_PREFERENCESDIALOG_H__
#define __C4S_PREFERENCESDIALOG_H__

#include <c4scripter/c4s-preferences.h>
#include <c4scripter/c4s-enginefunctionlist.h>

#include <gtk/gtkdialog.h>

G_BEGIN_DECLS

#define C4S_TYPE_PREFERENCES_DIALOG			(c4s_preferences_dialog_get_type())
#define C4S_PREFERENCES_DIALOG(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), C4S_TYPE_PREFERENCES_DIALOG, C4sPreferencesDialog))
#define C4S_PREFERENCES_DIALOG_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST((klass), C4S_TYPE_PREFERENCES_DIALOG, C4sPreferencesDialogClass))
#define C4S_IS_PREFERENCES_DIALOG(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), C4S_TYPE_PREFERENCES_DIALOG))
#define C4S_IS_PREFERENCES_DIALOG_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), C4S_TYPE_PREFERENCES_DIALOG))
#define C4S_PREFERENCES_DIALOG_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), C4S_TYPE_PREFERENCES_DIALOG, C4sPreferencesDialogClass))

typedef struct _C4sPreferencesDialogClass C4sPreferencesDialogClass;
typedef struct _C4sPreferencesDialog C4sPreferencesDialog;

struct _C4sPreferencesDialogClass
{
  GtkDialogClass parent_class;
};

struct _C4sPreferencesDialog
{
  GtkDialog parent_instance;
};

GType
c4s_preferences_dialog_get_type(void) G_GNUC_CONST;

C4sPreferencesDialog*
c4s_preferences_dialog_new(GtkWindow* parent,
                           GtkDialogFlags flags,
                           C4sPreferences* preferences,
                           C4sEngineFunctionList* engine_function_list);

G_END_DECLS

#endif /* __C4S_PREFERENCESDIALOG_H__ */
