/* c4scripter - A GTK+ based C4Script editor
 * Copyright (C) 2006 Bernhard Bonigl, Armin Burgmeier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __C4S_VALUETYPE_H__
#define __C4S_VALUETYPE_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define C4S_TYPE_VALUE_TYPE			(c4s_value_type_get_type())

typedef enum _C4sValueType {
  C4S_VALUE_TYPE_UNKNOWN = 0x00,
  C4S_VALUE_TYPE_INT     = 0x01,
  C4S_VALUE_TYPE_ID      = 0x02,
  C4S_VALUE_TYPE_BOOL    = 0x04,
  C4S_VALUE_TYPE_STRING  = 0x08,
  C4S_VALUE_TYPE_OBJECT  = 0x10,
  C4S_VALUE_TYPE_ARRAY   = 0x20,
  C4S_VALUE_TYPE_ANY     = 0x3f,
  C4S_VALUE_TYPE_REF     = 0x80
} C4sValueType;

GType
c4s_value_type_get_type(void) G_GNUC_CONST;

const gchar*
c4s_value_type_to_string(C4sValueType type);

C4sValueType
c4s_value_type_from_string(const gchar* name,
                           gsize len);

G_END_DECLS

#endif /* __C4S_VALUETYPE_H__ */
